function varargout = CRPResults(varargin)
% CRPRESULTS MATLAB code for CRPResults.fig
%      CRPRESULTS, by itself, creates a new CRPRESULTS or raises the existing
%      singleton*.
%
%      H = CRPRESULTS returns the handle to a new CRPRESULTS or the handle to
%      the existing singleton*.
%
%      CRPRESULTS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CRPRESULTS.M with the given input arguments.
%
%      CRPRESULTS('Property','Value',...) creates a new CRPRESULTS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CRPResults_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CRPResults_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CRPResults

% Last Modified by GUIDE v2.5 24-May-2019 13:53:51

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CRPResults_OpeningFcn, ...
                   'gui_OutputFcn',  @CRPResults_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CRPResults is made visible.
function CRPResults_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CRPResults (see VARARGIN)

% Choose default command line output for CRPResults
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes CRPResults wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% Run initialization of GUI values from design input GUI
initializeResults(handles);

set(handles.figure1, 'CloseRequestFcn', @closeGUI);


% --- Outputs from this function are returned to the command line.
function varargout = CRPResults_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function initializeResults(handles)

% Load default optimizer results file into the workspace
load("OptimizerResults.mat");

% Update table values for forward propeller
forwardCells = cell(length(RC1),9);
forwardCells(:,1) = num2cell(RC1);
forwardCells(:,2) = num2cell(G1);
forwardCells(:,3) = num2cell(UA_SELF1);
forwardCells(:,4) = num2cell(UT_SELF1);
forwardCells(:,5) = num2cell(UA_INT1_2);
forwardCells(:,6) = num2cell(UT_INT1_2);
forwardCells(:,7) = num2cell(TANBIC1);
forwardCells(:,8) = num2cell(VSTAR1);
forwardCells(:,9) = num2cell(Cl1);
set(handles.forwardTable, 'Data', forwardCells);

% Update table values for aft propeller
aftCells = cell(length(RC2),9);
aftCells(:,1) = num2cell(RC2);
aftCells(:,2) = num2cell(G2);
aftCells(:,3) = num2cell(UA_SELF2);
aftCells(:,4) = num2cell(UT_SELF2);
aftCells(:,5) = num2cell(UA_INT2_1);
aftCells(:,6) = num2cell(UT_INT2_1);
aftCells(:,7) = num2cell(TANBIC2);
aftCells(:,8) = num2cell(VSTAR2);
aftCells(:,9) = num2cell(Cl2);
set(handles.aftTable, 'Data', aftCells);

% Update coefficient values
set(handles.EFFY, 'String', num2str(EFFY));
set(handles.CQ1, 'String', num2str(CQ1));
set(handles.CQ2, 'String', num2str(CQ2));
set(handles.CT1, 'String', num2str(CT1));
set(handles.CT2, 'String', num2str(CT2));
set(handles.KQ1, 'String', num2str(KQ1));
set(handles.KQ2, 'String', num2str(KQ2));
set(handles.KT1, 'String', num2str(KT1));
set(handles.KT2, 'String', num2str(KT2));

% Initialize plot
axes(handles.resultPlot);
plot(RC1, G1, RC2, G2);
leg = legend('G1', 'G2');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Circulation");
grid on;

% --- Executes on button press in radio_G.
function radio_G_Callback(hObject, eventdata, handles)
% hObject    handle to radio_G (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_G

load("OptimizerResults.mat");

% Update GUI axes with nondimensional circulation values
axes(handles.resultPlot);
plot(RC1, G1, RC2, G2);
leg = legend('G1', 'G2');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Circulation");
grid on;


% --- Executes on button press in radio_UA_SELF.
function radio_UA_SELF_Callback(hObject, eventdata, handles)
% hObject    handle to radio_UA_SELF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_UA_SELF

load("OptimizerResults.mat");

% Update GUI axes with self-induced axial velocity values
axes(handles.resultPlot);
plot(RC1, UA_SELF1, RC2, UA_SELF2);
leg = legend('UA_SELF1', 'UA_SELF2');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Axial self induced velocities");
grid on;


% --- Executes on button press in radio_UT_SELF.
function radio_UT_SELF_Callback(hObject, eventdata, handles)
% hObject    handle to radio_UT_SELF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_UT_SELF

load("OptimizerResults.mat");

% Update GUI tangential with self-induced axial velocity values
axes(handles.resultPlot);
plot(RC1, UT_SELF1, RC2, UT_SELF2);
leg = legend('UT_SELF1', 'UT_SELF2');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Tangential self induced velocities");
grid on;


% --- Executes on button press in radio_TANBIC.
function radio_TANBIC_Callback(hObject, eventdata, handles)
% hObject    handle to radio_TANBIC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_TANBIC

load("OptimizerResults.mat");

% Update GUI axes with tangent of pitch angles
axes(handles.resultPlot);
plot(RC1, TANBIC1, RC2, TANBIC2);
leg = legend('TANBIC1', 'TANBIC2');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Tangent of hydrodynamic pitch angle");
grid on;


% --- Executes on button press in radio_VSTAR.
function radio_VSTAR_Callback(hObject, eventdata, handles)
% hObject    handle to radio_VSTAR (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_VSTAR

load("OptimizerResults.mat");

% Update GUI axes with total resultant inflow velocity values
axes(handles.resultPlot);
plot(RC1, VSTAR1, RC2, VSTAR2);
leg = legend('VSTAR1', 'VSTAR2');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Total inflow velocity");
grid on;


% --- Executes on button press in radio_UA_INT.
function radio_UA_INT_Callback(hObject, eventdata, handles)
% hObject    handle to radio_UA_INT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_UA_INT

load("OptimizerResults.mat");

% Update GUI axes with axial interaction velocity values
axes(handles.resultPlot);
plot(RC1, UA_INT1_2, RC2, UA_INT2_1);
leg = legend('UA_INT1_2', 'UA_INT2_1');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Axial interaction velocities");
grid on;


% --- Executes on button press in radio_UT_INT.
function radio_UT_INT_Callback(hObject, eventdata, handles)
% hObject    handle to radio_UT_INT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_UT_INT

load("OptimizerResults.mat");

% Update GUI axes with tangential interaction velocity values
axes(handles.resultPlot);
plot(RC1, UT_INT1_2, RC2, UT_INT2_1);
leg = legend('UT_INT1_2', 'UT_INT2_1');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Tangential interaction velocities");
grid on;


% --- Executes on button press in radio_Cl.
function radio_Cl_Callback(hObject, eventdata, handles)
% hObject    handle to radio_Cl (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_Cl

load("OptimizerResults.mat");

% Update GUI axes with required lift coefficient distribution
axes(handles.resultPlot);
plot(RC1, Cl1, RC2, Cl2);
leg = legend('Cl1', 'Cl2');
set(leg, 'Interpreter', 'none');
xlabel("RC1 | RC2");
ylabel("Required lift coefficient");
grid on;

function closeGUI(hObject, eventdata, handles)

% Prompt user to save results
answer = questdlg('Save results to another file before quitting?', 'Yes', 'No');

switch answer
    case 'Yes'
        load("OptimizerResults.mat"); % Load variables into workspace
        uisave; % Save values to ,mat file
        delete(hObject); % Close GUI
    case 'No'
        delete(hObject); % Close GUI
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

load("OptimizerResults.mat");

% Geometry module of Laskos
CoD1 = pchip(XR1,XCoD1,RC1);
CoD2 = pchip(XR2,XCoD2,RC2);

Gamma1=G1*2*pi*R1*Vs;
Gamma2=G2*2*pi*R2*Vs;
Cl1= 2*Gamma1'./(VSTAR1*Vs.*CoD1.*2*R1);
Cl2= 2*Gamma2'./(VSTAR2*Vs.*CoD2.*2*R2);
% ============= Inputs necessary for geometry generation ==================
skew01 = zeros(1,11); % Skew [deg]
skew02 = zeros(1,11);
rake01 = zeros(1,11); % Xs/D, Rake
rake02 = zeros(1,11);
% --------------------- t0/c, thickness / chord ---------------------------
t0oc01 = [.2056 .1551 .1181 .0902 .0694 .0541 .0419 .0332 .0324...
 .0204 .005];
 %[0.0815 0.0771 0.0731 0.0664 0.0608 0.0561 0.0522...
 % 0.0489 0.0457 0.0457 0.005];
t0oc02 = t0oc01;
% -------------------------------------------------------------------------
BetaI_c1=atand(TANBIC1);
BetaI_c2=atand(TANBIC2);
Np=40; % Number of points over the chord
% ======================= Generate Propeller Geometry =====================
Geometry(XR1,XR2,t0oc01,t0oc02,skew01,skew02,rake01,rake02,RC1,RC2,Cl1,...
 Cl2,BetaI_c1,BetaI_c2,Xf,Z1,Z2,Rhub,CoD1,CoD2,R1,R2,M1,M2,Np)


% --- Executes on button press in openPlotButton.
function openPlotButton_Callback(hObject, eventdata, handles)
% hObject    handle to openPlotButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Open plot in external figure for editing
f1 = figure; % Open a new figure with handle f1
copyobj(handles.resultPlot,f1); % Copy axes object h into figure f1
set(gca,'ActivePositionProperty','outerposition')
set(gca,'Units','normalized')
set(gca,'OuterPosition',[0 0 1 1])
set(gca,'position',[0.1300 0.1100 0.7750 0.8150])


% --- Executes on button press in helpButton.
function helpButton_Callback(hObject, eventdata, handles)
% hObject    handle to helpButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Open .txt file with nomenclature and unit explanations
winopen('DesignOutputs.txt');

