function [UAHIF,UTHIF] = Horseshoe_self(Mp,Z,TANBIV,RC,RV,Hub_Flag,...
    Rhub_oR)
for n = 1:Mp % for each control point, n (FOR LOOP MF2)
    for m = 1:Mp+1 % for each vortex point, m (FOR LOOP MF3)
        % -- Find induction factors for a unit vortex shed at RV(m)
        % -- Wrench returns 2*pi*R*u_bar
        [UAW(m),UTW(m)] = Wrench(Z,TANBIV(m),RC(n),RV(m));
        % ---------------------------- Find hub-image effects, Kerwin p.181
        if Hub_Flag == 1
            RCW = RC(n);
            RVW = Rhub_oR^2/RV(m);
            TANBIW = TANBIV(1)*RV(1)/RVW;
            [UAWh,UTWh] = Wrench(Z,TANBIW,RCW,RVW);
            UAW(m) = UAW(m)-UAWh;
            UTW(m) = UTW(m)-UTWh;
        end
    end % (END FOR LOOP MF3)
    % The Horseshoe Influence Function for vortex panel m is the
    % effect of the induction by a helical trailing vortex at
    % vortex point m with circulation -Gamma(m) and another at
    % vortex point m+1 with circulation +Gamma(m).
    % UAHIF(n,m) = u_barA horseshoe influence function in eqn 254.
    % UAW(m) = u_barA Wrench velocity given in eqn 202-203.
    for m = 1:Mp % for each vortex panel, m
        UAHIF(n,m) = UAW(m+1)-UAW(m); % 2*pi*R*(HIF)
        UTHIF(n,m) = UTW(m+1)-UTW(m); % 2*pi*R*(HIF)
    end
    
end % (END FOR LOOP MF2)
end
% ================================================== END Horseshoe Function
% =========================================================================